import { Midi, Track } from "@tonejs/midi";
import { Note, Segment } from ".";
import SimpleMidi from "./simple-midi";
export declare const MAX_BREATH_SECONDS = 7;
export declare const getValidTracks: (midi: Midi) => Track[];
export declare const shiftMidi: (midi: Midi, amount: number) => void;
export declare const getSimplePartitioningArray: (arr: number[]) => number[];
export declare const getPartitioningArrayWithMax: (arr: number[], max: number) => number[];
export declare const sliceAndDice: <T>(arr: T[], indicesToSliceAt: number[]) => T[][];
export declare const getBeatLength: (bpm: number) => number;
export declare const getDurationOfNotes: (notes: Note[]) => number;
export declare const base64ToBinary: (base64String: string) => ArrayBuffer;
export declare const processMidiFile: (midi: SimpleMidi) => Segment[];
export declare function getSegmentOffset(firstNoteStart: number, beatLength: number, shift: number): number;
export declare function base64ToArrayBuffer(base64: string): ArrayBuffer;
