"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const midi_1 = require("@tonejs/midi");
class Midi extends midi_1.Midi {
    constructor(buffer, bpm) {
        super(buffer);
        this.simpleBpm = bpm;
    }
    static fromBuffer(buffer) {
        try {
            const midi = new midi_1.Midi(buffer);
            const bpm = midi.header.tempos[0].bpm;
            return new Midi(buffer, bpm);
        }
        catch (e) {
            console.info("Buffer isn't valid Midi or SimpleMidi");
            console.info(e);
            return null;
        }
    }
    static fromBase64(str) {
        return Midi.fromBuffer(Buffer.from(str, "base64"));
    }
    getAllNotes() {
        const res = [];
        for (const track of this.tracks) {
            for (const note of track.notes) {
                res.push({
                    time: note.time,
                    midi: note.midi,
                    duration: note.duration,
                    velocity: note.velocity,
                });
            }
        }
        return res;
    }
}
exports.default = Midi;
